#!/usr/bin/awk -f

# https://www.grymoire.com/Unix/Awk.html

# printf for finer tuning of output formatting

# printf is just another print() function, but it gives you
# more control over the formatting of the string that is
# printed

# printf expects you to provide it with a lot more detail into
# how you want a string printed, even down to the character
# that terminates a line.  print() by default will end a line
# with the ORS character, usually \n.  printf() expects you
# to add your own line terminator wherever you want it.

# in the previous example, 05.awk, we printed out usernames
# and the number of login sessions they have open.

# in this example, let's use print to format that output so
# that it looks a little better.


{
    users[$1]++
}

END {
    for (i in users) {
        printf("%-8s %2d\n", i, users[i])
    }
}

# again, run this as w | ./06.awk
